# sdr_beta.s - YAT loader (DOS)
# Copyright (C) 2000 Tachibana Eriko
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA


* Include File -------------------------------- *

		.include	macro.mac
		.include	doscall.mac


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

_dos_yat::
		PUSH	d3-d7/a3-a6
		movem.l	(9*4+4,sp),d6/d7/a3/a5
		lsl.l	#2,d7			;frame_num
		lea	(a3),a4			;tbl_ptr
		adda.l	d7,a4			;tbl_end
loop_f:
		cmpa.l	a3,a4
		bcs	return

		move.l	(a3),-(sp)		;frame_size
		pea	(a5)			;buf
		move	d6,-(sp)		;fd
		DOS	_READ
		lea	(10,sp),sp
		cmp.l	(a3)+,d0
		bne	return

		pea	(a5)
		.xref	_YatDecode
		bsr	_YatDecode
		addq.l	#4,sp

		move	#1,-(sp)
		DOS	_KEYCTRL
		addq.l	#2,sp
		tst.l	d0
		beq	loop_f
		clr	-(sp)
		DOS	_KEYCTRL
		addq.l	#2,sp
		cmpi.b	#$1b,d0
		bne	loop_f

		move	#2,-(sp)
		DOS	_KEYCTRL
		addq.l	#2,sp
		moveq	#1,d1
		and.l	d1,d0
		bra	@f
return:
		moveq	#0,d0
@@:
		POP	d3-d7/a3-a6
		rts


		.end

* End of File --------------------------------- *
